<?php
/**
* @version      1.0.0 21.10.2016
* @author       MAXXmarketing GmbH
* @package      Wopshop User Registration Captcha
* @copyright    Copyright (C) 2010 http://www.wop-agentur.com. All rights reserved.
*/
if (!defined('ABSPATH')) {
    exit; // Exit if accessed directly
}

class RegistrationcaptchaWshopAddon extends WshopAddon {
    
    protected $addon_alias = 'registration_captcha';

    public function loadActions(){
		add_action( 'onBeforeRegister', array($this, 'onBeforeRegister'), 10, 2);
		add_action( 'onBeforeDisplayRegisterView', array($this, 'onBeforeDisplayRegisterView'));
    }

	function onBeforeRegister(&$post, &$default_usergroup){
		$this->loadLanguage();
		$params = $this->getAddonParams();
		$app = Factory::getApplication();
		$config = Factory::getConfig();
		$session = Factory::getSession();
		if ($params->recaptcha_public_key && $params->recaptcha_private_key){
			$recaptcha_secret = $params->recaptcha_private_key;
			$response = wp_remote_get("https://www.google.com/recaptcha/api/siteverify?secret=". $recaptcha_secret ."&response=". $_POST['g-recaptcha-response']);
			$response = json_decode($response["body"], true);
			if (true == $response["success"]) {
				return 1;
			} else {
				$registrationdata = Request::get('post');
				$session->set('registrationdata', $registrationdata);
				addMessage(_GR_WRONG_CODE, 'error');
				$app->redirect(SEFLink("controller=user&task=register&lrd=1", 1, 1, $config->use_ssl));
			}			
		}
	}
			
	function onBeforeDisplayRegisterView(&$view){
        wp_enqueue_script('recaptcha.api.js', 'https://www.google.com/recaptcha/api.js');
		$this->loadLanguage();
		$params = $this->getAddonParams();
		if ($params->recaptcha_public_key && $params->recaptcha_private_key)
		$view->_tmpl_register_html_5 .= '<div class="control-group"><div class="control-label name">'._GR_INSERT_CODE.' <span>*</span></div><div class="controls"><div class="g-recaptcha" data-sitekey="'.$params->recaptcha_public_key.'"></div></div></div>';
	}
}